Bug 447475 - 64-bit strace cannot follow 32-bit vfork
64-bit strace cannot follow 32-bit vfork
Product: Fedora
Classification: Fedora
Component: strace (Show other bugs)
x86_64 Linux
high Severity high
: ---
: ---
Assigned To: Roland McGrath
Fedora Extras Quality Assurance
Depends On:
Blocks: 445849
  Show dependency treegraph
Reported: 2008-05-19 20:30 EDT by Roland McGrath
Modified: 2009-07-14 09:59 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2009-07-14 09:59:18 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Roland McGrath 2008-05-19 20:30:52 EDT
The -fF magic fails for 64-bit strace handling a 32-bit binary using the vfork
syscall.  Trivial test: echo 'int main(){if(vfork())wait((int*)0);else _exit(0);
return 0;}'| cc -xc - -m32 -o x; strace -fFq ./x
Comment 1 Denys Vlasenko 2008-09-09 07:42:53 EDT
Seems to be fixed in upstream and in strace-4.5.18 which makes its way to Fedora 9 and 8 just now.

At this moment, strace in Fedora 9 is at version 4.5.16, which fails to follow vfork. Test program:

#include <stdio.h>
int main() {
        int r = vfork();
        fprintf(stderr, "vfork():%d\n", r);

On my Fedora 9 machine:

Building 32-bit binary:

# i486-linux-uclibc-gcc -Os t.c
t.c: In function 'main':
t.c:5: warning: incompatible implicit declaration of built-in function '_exit'

Testing strace:

# strace -f -oz ./a.out
[ Process PID=20876 runs in 32 bit mode. ]

# strace -V
strace -- version 4.5.16

# yum update strace
Loaded plugins: refresh-packagekit
Could not find update match for strace
No Packages marked for Update

A locally built upstream version:

# /root/srcdevel/strace/fix/strace.t0/strace -f -oz ./a.out
[ Process PID=21678 runs in 32 bit mode. ]

# /root/srcdevel/strace/fix/strace.t0/strace -V
strace -- version 4.5.18
Comment 2 Bug Zapper 2009-06-09 21:01:37 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
Comment 3 Bug Zapper 2009-07-14 09:59:18 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.